from fastapi import APIRouter, File, Form, HTTPException, UploadFile
import uuid
from app.storage.upload import upload_file_to_azure_blob, delete_file_from_azure_blob

router = APIRouter()


@router.post("/upload")
async def upload_file(file: UploadFile = File(...), folder: str = Form(...)):
    try:
        random_id = str(uuid.uuid4())[:8]
        file_path = f"{folder}/{random_id}-{file.filename}".replace(" ", "")
        result = upload_file_to_azure_blob(file, file_path)
        return result
    except Exception as e:
        raise HTTPException(status_code=500, detail=f"Error uploading file: {str(e)}")


@router.post("/delete")
async def delete_file(file_url: str = Form(...)):
    try:
        file_name = file_url.split("media/")[-1]
        delete_file_from_azure_blob(file_name, "media")
        return {"message": "File deleted successfully."}
    except Exception as e:
        raise HTTPException(status_code=500, detail=f"Error deleting file: {str(e)}")
